WHATSNEW: add SmartCard/PKINIT improvements
[vlendec/samba-autobuild/.git] / wscript
1 #!/usr/bin/env python
2
3 srcdir = '.'
4 blddir = 'bin'
5
6 APPNAME='samba'
7 VERSION=None
8
9 import sys, os, tempfile
10 sys.path.insert(0, srcdir+"/buildtools/wafsamba")
11 import wafsamba, Options, samba_dist, samba_git, Scripting, Utils, samba_version
12
13
14 samba_dist.DIST_DIRS('.')
15 samba_dist.DIST_BLACKLIST('.gitignore .bzrignore source4/selftest/provisions')
16
17 # install in /usr/local/samba by default
18 default_prefix = Options.default_prefix = '/usr/local/samba'
19
20 # This callback optionally takes a list of paths as arguments:
21 # --with-system_mitkrb5 /path/to/krb5 /another/path
22 def system_mitkrb5_callback(option, opt, value, parser):
23     setattr(parser.values, option.dest, True)
24     value = []
25     for arg in parser.rargs:
26         # stop on --foo like options
27         if arg[:2] == "--" and len(arg) > 2:
28             break
29         value.append(arg)
30     if len(value)>0:
31         del parser.rargs[:len(value)]
32         setattr(parser.values, option.dest, value)
33
34 def set_options(opt):
35     opt.BUILTIN_DEFAULT('NONE')
36     opt.PRIVATE_EXTENSION_DEFAULT('samba4')
37     opt.RECURSE('lib/replace')
38     opt.RECURSE('dynconfig')
39     opt.RECURSE('lib/ldb')
40     opt.RECURSE('selftest')
41     opt.RECURSE('source4/lib/tls')
42     opt.RECURSE('source4/dsdb/samdb/ldb_modules')
43     opt.RECURSE('pidl')
44     opt.RECURSE('source3')
45     opt.RECURSE('lib/util')
46     opt.RECURSE('ctdb')
47
48     opt.add_option('--with-system-mitkrb5',
49                    help='enable system MIT krb5 build (includes Samba 4 client and Samba 3 code base).'+
50                         'You may specify list of paths where Kerberos is installed (e.g. /usr/local /usr/kerberos) to search krb5-config',
51                    action='callback', callback=system_mitkrb5_callback, dest='with_system_mitkrb5', default=False)
52
53     opt.add_option('--without-ad-dc',
54                    help='disable AD DC functionality (enables Samba 4 client and Samba 3 code base).',
55                    action='store_true', dest='without_ad_dc', default=False)
56
57     opt.add_option('--with-ntvfs-fileserver',
58                    help='enable the depricated NTVFS file server from the original Samba4 branch (default if --enable-selftest specicifed).  Conflicts with --with-system-mitkrb5 and --without-ad-dc',
59                    action='store_true', dest='with_ntvfs_fileserver')
60
61     opt.add_option('--without-ntvfs-fileserver',
62                    help='disable the depricated NTVFS file server from the original Samba4 branch',
63                    action='store_false', dest='with_ntvfs_fileserver')
64
65     opt.add_option('--with-pie',
66                   help=("Build Position Independent Executables " +
67                         "(default if supported by compiler)"),
68                   action="store_true", dest='enable_pie')
69     opt.add_option('--without-pie',
70                   help=("Disable Position Independent Executable builds"),
71                   action="store_false", dest='enable_pie')
72
73     opt.add_option('--with-relro',
74                   help=("Build with full RELocation Read-Only (RELRO)" +
75                         "(default if supported by compiler)"),
76                   action="store_true", dest='enable_relro')
77     opt.add_option('--without-relro',
78                   help=("Disable RELRO builds"),
79                   action="store_false", dest='enable_relro')
80
81     gr = opt.option_group('developer options')
82
83     opt.tool_options('python') # options for disabling pyc or pyo compilation
84     # enable options related to building python extensions
85
86
87 def configure(conf):
88     version = samba_version.load_version(env=conf.env)
89
90     conf.DEFINE('CONFIG_H_IS_FROM_SAMBA', 1)
91     conf.DEFINE('_SAMBA_BUILD_', version.MAJOR, add_to_cflags=True)
92     conf.DEFINE('HAVE_CONFIG_H', 1, add_to_cflags=True)
93
94     if Options.options.developer:
95         conf.ADD_CFLAGS('-DDEVELOPER -DDEBUG_PASSWORD')
96         conf.env.DEVELOPER = True
97
98     conf.ADD_EXTRA_INCLUDES('#include/public #source4 #lib #source4/lib #source4/include #include #lib/replace')
99
100     conf.env.replace_add_global_pthread = True
101     conf.RECURSE('lib/replace')
102
103     conf.SAMBA_CHECK_PERL(mandatory=True)
104     conf.find_program('xsltproc', var='XSLTPROC')
105
106     conf.SAMBA_CHECK_PYTHON(mandatory=True, version=(2, 6, 0))
107     conf.SAMBA_CHECK_PYTHON_HEADERS(mandatory=True)
108
109     if sys.platform == 'darwin' and not conf.env['HAVE_ENVIRON_DECL']:
110         # Mac OSX needs to have this and it's also needed that the python is compiled with this
111         # otherwise you face errors about common symbols
112         if not conf.CHECK_SHLIB_W_PYTHON("Checking if -fno-common is needed"):
113             conf.ADD_CFLAGS('-fno-common')
114         if not conf.CHECK_SHLIB_W_PYTHON("Checking if -undefined dynamic_lookup is not need"):
115             conf.env.append_value('shlib_LINKFLAGS', ['-undefined', 'dynamic_lookup'])
116
117     if sys.platform == 'darwin':
118         conf.ADD_LDFLAGS('-framework CoreFoundation')
119
120     if int(conf.env['PYTHON_VERSION'][0]) >= 3:
121         raise Utils.WafError('Python version 3.x is not supported by Samba yet')
122
123     conf.RECURSE('dynconfig')
124
125     if conf.CHECK_FOR_THIRD_PARTY():
126         conf.RECURSE('third_party')
127     else:
128         if not conf.CHECK_ZLIB():
129             raise Utils.WafError('zlib development packages have not been found.\nIf third_party is installed, check that it is in the proper place.')
130         else:
131             conf.define('USING_SYSTEM_ZLIB',1)
132
133         if not conf.CHECK_POPT():
134             raise Utils.WafError('popt development packages have not been found.\nIf third_party is installed, check that it is in the proper place.')
135         else:
136             conf.define('USING_SYSTEM_POPT', 1)
137
138     conf.RECURSE('lib/ldb')
139
140     if not (Options.options.without_ad_dc):
141         conf.DEFINE('AD_DC_BUILD_IS_ENABLED', 1)
142
143     if Options.options.with_system_mitkrb5:
144         conf.PROCESS_SEPARATE_RULE('system_mitkrb5')
145     if not (Options.options.without_ad_dc or Options.options.with_system_mitkrb5):
146         conf.DEFINE('AD_DC_BUILD_IS_ENABLED', 1)
147
148     # Only process heimdal_build for non-MIT KRB5 builds
149     # When MIT KRB5 checks are done as above, conf.env.KRB5_VENDOR will be set
150     # to the lowcased output of 'krb5-config --vendor'.
151     # If it is not set or the output is 'heimdal', we are dealing with
152     # system-provided or embedded Heimdal build
153     if conf.CONFIG_GET('KRB5_VENDOR') in (None, 'heimdal'):
154         conf.RECURSE('source4/heimdal_build')
155     conf.RECURSE('source4/lib/tls')
156     conf.RECURSE('source4/dsdb/samdb/ldb_modules')
157     conf.RECURSE('source4/ntvfs/sysdep')
158     conf.RECURSE('lib/util')
159     conf.RECURSE('lib/util/charset')
160     conf.RECURSE('source4/auth')
161     conf.RECURSE('nsswitch')
162     conf.RECURSE('libcli/smbreadline')
163     conf.RECURSE('lib/crypto')
164     conf.RECURSE('pidl')
165     conf.RECURSE('selftest')
166     if conf.CONFIG_GET('ENABLE_SELFTEST'):
167         conf.RECURSE('lib/nss_wrapper')
168         conf.RECURSE('lib/resolv_wrapper')
169         conf.RECURSE('lib/socket_wrapper')
170         conf.RECURSE('lib/uid_wrapper')
171         if Options.options.with_ntvfs_fileserver != False:
172             if not (Options.options.without_ad_dc or Options.options.with_system_mitkrb5):
173                 conf.DEFINE('WITH_NTVFS_FILESERVER', 1)
174         if Options.options.with_ntvfs_fileserver == False:
175             if not (Options.options.without_ad_dc or Options.options.with_system_mitkrb5):
176                 raise Utils.WafError('--without-ntvfs-fileserver conflicts with --enable-selftest while building the AD DC')
177
178     if Options.options.with_ntvfs_fileserver == True:
179         if Options.options.without_ad_dc:
180             raise Utils.WafError('--with-ntvfs-fileserver conflicts with --without-ad-dc')
181         if Options.options.with_system_mitkrb5:
182             raise Utils.WafError('--with-ntvfs-fileserver conflicts with --with-system-mitkrb5')
183         conf.DEFINE('WITH_NTVFS_FILESERVER', 1)
184     conf.RECURSE('source3')
185     conf.RECURSE('lib/texpect')
186     if conf.env.with_ctdb:
187         conf.RECURSE('ctdb')
188     conf.RECURSE('lib/socket')
189
190     conf.SAMBA_CHECK_UNDEFINED_SYMBOL_FLAGS()
191
192     # gentoo always adds this. We want our normal build to be as
193     # strict as the strictest OS we support, so adding this here
194     # allows us to find problems on our development hosts faster.
195     # It also results in faster load time.
196
197     conf.env.asneeded_ldflags = conf.ADD_LDFLAGS('-Wl,--as-needed', testflags=True)
198
199     if not conf.CHECK_NEED_LC("-lc not needed"):
200         conf.ADD_LDFLAGS('-lc', testflags=False)
201
202     if not conf.CHECK_CODE('#include "tests/summary.c"',
203                            define='SUMMARY_PASSES',
204                            addmain=False,
205                            msg='Checking configure summary'):
206         raise Utils.WafError('configure summary failed')
207
208     if Options.options.enable_pie != False:
209         if Options.options.enable_pie == True:
210                 need_pie = True
211         else:
212                 # not specified, only build PIEs if supported by compiler
213                 need_pie = False
214         if conf.check_cc(cflags='-fPIE', ldflags='-pie', mandatory=need_pie,
215                          msg="Checking compiler for PIE support"):
216             conf.env['ENABLE_PIE'] = True
217
218     if Options.options.enable_relro != False:
219         if Options.options.enable_relro == True:
220             need_relro = True
221         else:
222             # not specified, only build RELROs if supported by compiler
223             need_relro = False
224         if conf.check_cc(cflags='', ldflags='-Wl,-z,relro,-z,now', mandatory=need_relro,
225                          msg="Checking compiler for full RELRO support"):
226             conf.env['ENABLE_RELRO'] = True
227
228     conf.SAMBA_CONFIG_H('include/config.h')
229
230 def etags(ctx):
231     '''build TAGS file using etags'''
232     import Utils
233     source_root = os.path.dirname(Utils.g_module.root_path)
234     cmd = 'rm -f %s/TAGS && (find %s -name "*.[ch]" | egrep -v \.inst\. | xargs -n 100 etags -a)' % (source_root, source_root)
235     print("Running: %s" % cmd)
236     status = os.system(cmd)
237     if os.WEXITSTATUS(status):
238         raise Utils.WafError('etags failed')
239
240 def ctags(ctx):
241     "build 'tags' file using ctags"
242     import Utils
243     source_root = os.path.dirname(Utils.g_module.root_path)
244     cmd = 'ctags --python-kinds=-i $(find %s -name "*.[ch]" | grep -v "*_proto\.h" | egrep -v \.inst\.) $(find %s -name "*.py")' % (source_root, source_root)
245     print("Running: %s" % cmd)
246     status = os.system(cmd)
247     if os.WEXITSTATUS(status):
248         raise Utils.WafError('ctags failed')
249
250
251 # putting this here enabled build in the list
252 # of commands in --help
253 def build(bld):
254     '''build all targets'''
255     samba_version.load_version(env=bld.env, is_install=bld.is_install)
256
257
258 def pydoctor(ctx):
259     '''build python apidocs'''
260     bp = os.path.abspath('bin/python')
261     mpaths = {}
262     modules = ['talloc', 'tdb', 'ldb']
263     for m in modules:
264         f = os.popen("PYTHONPATH=%s python -c 'import %s; print %s.__file__'" % (bp, m, m), 'r')
265         try:
266             mpaths[m] = f.read().strip()
267         finally:
268             f.close()
269     mpaths['main'] = bp
270     cmd = ('PYTHONPATH=%(main)s pydoctor --introspect-c-modules --project-name=Samba '
271            '--project-url=http://www.samba.org --make-html --docformat=restructuredtext '
272            '--add-package bin/python/samba ' + ''.join('--add-module %s ' % n for n in modules))
273     cmd = cmd % mpaths
274     print("Running: %s" % cmd)
275     status = os.system(cmd)
276     if os.WEXITSTATUS(status):
277         raise Utils.WafError('pydoctor failed')
278
279
280 def pep8(ctx):
281     '''run pep8 validator'''
282     cmd='PYTHONPATH=bin/python pep8 -r bin/python/samba'
283     print("Running: %s" % cmd)
284     status = os.system(cmd)
285     if os.WEXITSTATUS(status):
286         raise Utils.WafError('pep8 failed')
287
288
289 def wafdocs(ctx):
290     '''build wafsamba apidocs'''
291     from samba_utils import recursive_dirlist
292     os.system('pwd')
293     list = recursive_dirlist('../buildtools/wafsamba', '.', pattern='*.py')
294
295     cmd='PYTHONPATH=bin/python pydoctor --project-name=wafsamba --project-url=http://www.samba.org --make-html --docformat=restructuredtext'
296     print(list)
297     for f in list:
298         cmd += ' --add-module %s' % f
299     print("Running: %s" % cmd)
300     status = os.system(cmd)
301     if os.WEXITSTATUS(status):
302         raise Utils.WafError('wafdocs failed')
303
304
305 def dist():
306     '''makes a tarball for distribution'''
307     sambaversion = samba_version.load_version(env=None)
308
309     os.system("make -C ctdb/doc")
310     samba_dist.DIST_FILES('ctdb/doc:ctdb/doc', extend=True)
311
312     os.system(srcdir + "/release-scripts/build-manpages-nogit")
313     samba_dist.DIST_FILES('bin/docs:docs', extend=True)
314
315     if sambaversion.IS_SNAPSHOT:
316         # write .distversion file and add to tar
317         if not os.path.isdir(blddir):
318             os.makedirs(blddir)
319         distversionf = tempfile.NamedTemporaryFile(mode='w', prefix='.distversion',dir=blddir)
320         for field in sambaversion.vcs_fields:
321             distveroption = field + '=' + str(sambaversion.vcs_fields[field])
322             distversionf.write(distveroption + '\n')
323         distversionf.flush()
324         samba_dist.DIST_FILES('%s:.distversion' % distversionf.name, extend=True)
325
326         samba_dist.dist()
327         distversionf.close()
328     else:
329         samba_dist.dist()
330
331
332 def distcheck():
333     '''test that distribution tarball builds and installs'''
334     samba_version.load_version(env=None)
335     import Scripting
336     d = Scripting.distcheck
337     d()
338
339 def wildcard_cmd(cmd):
340     '''called on a unknown command'''
341     from samba_wildcard import run_named_build_task
342     run_named_build_task(cmd)
343
344 def main():
345     from samba_wildcard import wildcard_main
346
347     wildcard_main(wildcard_cmd)
348 Scripting.main = main
349
350 def reconfigure(ctx):
351     '''reconfigure if config scripts have changed'''
352     import samba_utils
353     samba_utils.reconfigure(ctx)
354
355
356 if os.path.isdir(os.path.join(srcdir, ".git")):
357     # Check if there are submodules that are checked out but out of date.
358     for submodule, status in samba_git.read_submodule_status(srcdir):
359         if status == "out-of-date":
360             raise Utils.WafError("some submodules are out of date. Please run 'git submodule update'")